/*	Sample program for Olimex AVR-USB-162 with AT90USB162 processor
 *	Toggle OC.1A - PC6 (Pin 23) with Frequency = Freq
 *	Compile with AVRStudio+WinAVR (gcc version 3.4.6)
 */

#include "avr/io.h"

long OSCSPEED = 4000160;
long Freq = 75638;	//1 - 4 000 000 Hz

double R;
long BrCycle;

int main()
{
	DDRC = DDRC | 0b01000000;		//set OC.1A (Bit6 = 1) as output
	
	//set prescaler at min
	TCCR1B = (TCCR1B & 0b11111000) | 0b00000001;	//Bit2=0; Bit1=0; Bit0=1

	//set mode: Clear Timer on Compare (CTC) (WGM3:0 = 0100)
		//WGM0 = 0 (Bit0 = 0) ; WGM1 = 0 (Bit1 = 0)
		TCCR1A = TCCR1A & 0b11111100;
	
		//WGM2 = 1 (Bit3 = 1) ; WGM3 = 0 (Bit4 = 0)
		TCCR1B = (TCCR1B | 0b00001000) & 0b11101111;

	if (Freq < 62)
	{
		CLKPR = 0b10000000;	//enable changes on CLKPR register (Bit7 = 1)
		CLKPR = 0b00000011;	//set clock division factor to 8 (Bit3:2 = 0; Bit1:0 = 1)
		OSCSPEED = OSCSPEED / 8;
		if (Freq < 8)
		{
			//set prescaler to 1/8
			TCCR1B = (TCCR1B & 0b11111000) | 0b00000010;	//Bit2=0; Bit1=1; Bit0=0
			OSCSPEED = OSCSPEED / 8;
		}
	}
	else
	{
		CLKPR = 0b10000000;	//enable changes on CLKPR register (Bit7 = 1)
		CLKPR = 0b00000000;	//set clock division factor to 1 (Bit3:0 = 0)
	}



	//calculate total number of cycles
	R = (OSCSPEED / (double)Freq) - 1;
	BrCycle = (OSCSPEED / Freq) - 1;
	R = R - BrCycle + 0.5;
	if (R>=1) BrCycle++;

	//set COM1A mode to toggle pin (Bit7 = 0 ; Bit6 = 1)
	TCCR1A = (TCCR1A & 0b01111111) | 0b01000000;

	OCR1AH = (unsigned char) (BrCycle>>8);
	OCR1AL = (unsigned char) BrCycle;

	while (1)
	{
	}
}

